<?php
function ll_encode($str, $shift = 0) {
	$shift = strlen($_SERVER['HTTP_HOST']);
	if ($shift < 11) {
		$shift = $shift + rand((11 - $shift), (21 - $shift));
	} elseif ($shift > 25) {
		$shift = $shift - rand(($shift - 21), ($shift - 11));
	}
	$res = '';
	$len = strlen($str);
	if ($len > 0) {
		for ($i = 0; $i < $len; $i++) {
			$cur_char = substr($str, $i, 1);
			$cur_char = ord($cur_char) - $shift + round($i / 3);
			while (strlen($cur_char) < 3) { $cur_char = '0'.$cur_char; }
			$res .= $cur_char;
		}
		$res .= strval($shift + 127);
	}
	return $res;
}

function ll_decode($str) {
	$res = '';
	$len = strlen($str);
	if ($len > 0) {
		$shift = intval(substr($str, $len - 3)) - 127;
		$len -= 3;
		$str = substr($str, 0, $len);
		for ($i = 0; $i < $len; $i = $i + 3) {
			$cur_char = substr($str, $i, 3);
			$cur_char = chr($cur_char + $shift - round(($i / 3) / 3));
			$res .= $cur_char;
		}
	}
	return $res;
}

function ll_mysql_query($sql) {
	$rs = @mysql_query($sql) or die('<hr size= "1" /><br /><strong>Error: </strong>Error data access<br/>'.$sql.'<br />'.mysql_error());
	return $rs;
}

function ll_add_slashes($str) {
	return (get_magic_quotes_gpc()) ? $str : addslashes($str);
}

function ll_strip_slashes($str) {
	return (get_magic_quotes_gpc()) ? stripslashes($str) : $str;
}

function ll_save_file_context($filename, $context) {
	$res = false;
	$res = @file_put_contents($filename, $context);
	return $res;
}

function ll_get_file_context($filename) {
	$res = @file_get_contents($filename);
	if (ll_check_magic_quotes_runtime()) $res = stripslashes($res);
	return $res;
}

function ll_check_magic_quotes_runtime() {
	$res = false;
	$fn = 'mqr.txt';
	if (!file_exists($fn) or time() - filemtime($fn) > 60 * 60 * 24) {
		ll_save_file_context($fn, 'check_magic_quotes_runtime "123"='."'123' ".date('Y.m.d H:i:s'));
	}
	if (file_exists($fn) and is_readable($fn)) {
		$s = @file_get_contents($fn);
		if (strstr($s, chr(92)) !== false) $res = true;
	}
	return $res;
}

function ll_str_to_textarea($str) {
	$res = str_replace('<', '&lt;', $str);
	$res = str_replace('>', '&gt;', $res);
	return $res;
}

function ll_textarea_to_str($str) {
	$res = str_replace('&lt;', '<', $str);
	$res = str_replace('&gt;', '>', $res);
	return $res;
}

function get_link($id) {
	$res = '';
	$sql = "select * from `ll_links` where `id`='$id' limit 1";
	$rs = ll_mysql_query($sql);
	if (mysql_num_rows($rs)) {
		$res = mysql_fetch_array($rs);
	}
	return $res;
}

function get_link_url($id) {
	$res = '';
	$sql = "select `link` from `ll_links` where `id`=$id limit 1";
	$rs = ll_mysql_query($sql);
	if (mysql_num_rows($rs)) {
		$row = mysql_fetch_array($rs);
		$res = ll_strip_slashes($row['link']);
	}
	return $res;
}

function get_link_return_link($id) {
	$res = '';
	$sql = "select `return_link` from `ll_links` where `id`=$id limit 1";
	$rs = ll_mysql_query($sql);
	if (mysql_num_rows($rs)) {
		$row = mysql_fetch_array($rs);
		$res = ll_strip_slashes($row['return_link']);
	}
	return $res;
}

function get_link_userid($id) {
	$res = '';
	$sql = "select `user_id` from `ll_links` where `id`=$id limit 1";
	$rs = ll_mysql_query($sql);
	if (mysql_num_rows($rs)) {
		$row = mysql_fetch_array($rs);
		$res = $row['user_id'];
	}
	return $res;
}

function get_topic_title($id) {
	$res = 'unknown';
	$sql = "select `title` from `ll_topics` where `id`=$id limit 1";
	$rs = ll_mysql_query($sql);
	if (mysql_num_rows($rs)) {
		$row = mysql_fetch_array($rs);
		$res = ll_strip_slashes($row['title']);
	}
	return $res;
}

function get_topic_full_title($id) {
	$res = 'unknown';
	$sql = "select `topic_id`, `title` from `ll_topics` where `id`=$id limit 1";
	$rs = ll_mysql_query($sql);
	if (mysql_num_rows($rs)) {
		$row = mysql_fetch_array($rs);
		$res = ll_strip_slashes($row['title']);
		if ($row['topic_id'] > 0) {
			$res = get_topic_full_title($row['topic_id']).'&nbsp;&rarr;&nbsp;'.$res;
		}
	}
	return $res;
}

function get_topics() {
	$res = array();
	$sql = "select * from `ll_topics` order by `title` asc";
	$rs = ll_mysql_query($sql);
	if (mysql_num_rows($rs)) {
		while ($row = mysql_fetch_array($rs)) $res[] = $row;
	}
	return $res;
}

function start_session() {
	if (!isset($_SESSION)) {
		session_name('litelinks');
		@session_start();
		if (!session_is_registered('ll')) session_register('ll');
	}
}

function is_child($topics_arr, $parent_topic_id, $cur_topic_id) {
	foreach($topics_arr as $v) {
		if ($v['id'] == $cur_topic_id and $v['topic_id'] == $parent_topic_id) {
			return true;
		}
	}
	return false;
}

function build_childs_topic($topics_arr, $topic_id) {
	global $step;
	global $cur_topic_id;
	global $cur_link;
	global $cur_filter_status;
	global $cur_filter_check;
	$res = '';
	foreach($topics_arr as $v) {
		if ($v['topic_id'] == $topic_id) {
			$res .= '<li style="padding: 2px 4px; white-space: nowrap">';
			if ($cur_topic_id != $v['id'] or $cur_link > 0) {
				$res .= '<a href="'.$_SERVER['PHP_SELF'].'?t='.$v['id'];
				$s = '';
				if ($step) $s .= '&amp;step='.$step;
				if ($cur_filter_status) $s .= '&amp;fs='.$cur_filter_status;
				if ($cur_filter_check) $s .= '&amp;fc='.$cur_filter_check;
				$res .= $s.'"';
				if ($cur_topic_id == $v['id'] and $cur_link > 0) $res .= ' style="color: #006699;"';
				$res .= '>'.ll_strip_slashes($v['title']).'</a>';
			} else {
				$res .= ll_strip_slashes($v['title']);
			}
			if ($cur_topic_id == $v['id'] or is_child($topics_arr, $v['id'], $cur_topic_id)) {
				$s = build_childs_topic($topics_arr, $v['id'], $cur_topic_id, $cur_link);
				if ($s) {
					$res .= '<ul style="list-style: none; list-style-type: none; margin: 0px 0px 0px 15px; padding: 0px;">'.$s.'</ul>';
				}
			}
			$res .= '</li>';
		}
	}
	return $res;
}

function build_childs_topic_for_edit($topics_arr, $topic_id) {
	global $lr;
	global $step;
	$res = '';
	foreach($topics_arr as $v) {
		if ($v['topic_id'] == $topic_id) {
			if ($topic_id == 0) {
				$res .= '<tr id="topics_tree_for_edit_data">';
				$res .= '<form id="form_edit_topic" name="form_edit_topic" method="post" action="" enctype="multipart/form-data" target="_self">';
				$res .= '<td valign="top"><input name="tet_'.$v['id'].'" type="text" id="tet_'.$v['id'].'" size="50" value="'.ll_strip_slashes($v['title']).'" /><div style="margin-top: 4px;"><input name="btn_edit_topic" type="submit" id="btn_edit_topic" value="'.$lr[10].'" /></div></td>';
				$s = build_childs_topic_for_edit($topics_arr, $v['id']);
				$s .= '<div id="topics_tree_level_0"><input name="tf_new_subtopic" type="text" id="tf_new_subtopic" size="50" value="" /><input name="tf_parent_topic" type="hidden" id="tf_parent_topic" value="'.$v['id'].'" /></div>';
				$res .= '<td valign="top">'.$s.'</td>';
				$res .= '<input name="step" type="hidden" id="step" value="'.$step.'" />';
				$res .= '</form>';
				$res .= '</tr>';
			} else {
				$res .= '<div id="topics_tree_level_1"><input name="tet_'.$v['id'].'" type="text" id="tet_'.$v['id'].'" size="50" value="'.ll_strip_slashes($v['title']).'" /></div>';
			}
		}
	}
	return $res;
}

function build_topics_tree($for_edit = false) {
	$topics_arr = get_topics();
	reset($topics_arr);
	if ($for_edit) {
		$res = build_childs_topic_for_edit($topics_arr, 0);
	} else {
		global $step;
		global $cur_topic_id;
		global $cur_link;
		global $cur_filter_status;
		global $cur_filter_check;
		global $lr;
		$res = '<ul class="topics_tree">';
		$res .= '<li>';
		if ($cur_topic_id != 0 or $cur_link > 0) {
			$res .= '<a href="'.$_SERVER['PHP_SELF'];
			$s = '';
			if ($step) $s .= '?step='.$step;
			if ($cur_filter_status) $s .= ($s) ? '&amp;fs='.$cur_filter_status : '?fs='.$cur_filter_status;
			if ($cur_filter_check) $s .= ($s) ? '&amp;fc='.$cur_filter_check : '?fc='.$cur_filter_check;
			$res .= $s.'"';
			if ($cur_topic_id == 0 and $cur_link > 0) $res .= ' style="color: #006699;"';
			$res .= '>&lt;'.$lr[32].'&gt;</a>';
		} else {
			$res .= '&lt;'.$lr[32].'&gt;';
		}
		$res .= '</li>';
		$res .= build_childs_topic($topics_arr, 0);
		$res .= '</ul>';
	}
	return $res;
}

function get_child_ids() {
	global $cur_topic_id;
	$res = '';
	$sql = "select * from `ll_topics` where `topic_id`=$cur_topic_id";
	$rs = ll_mysql_query($sql);
	if (mysql_num_rows($rs)) {
		while ($row = mysql_fetch_array($rs)) {
			if ($res) $res .= ', ';
			$res .= $row['id'];
		}
	}
	return $res;
}

function build_links_list($for_admin = false) {
	global $step;
	global $cur_topic_id;
	global $cur_page;
	global $cur_link;
	global $cur_filter_status;
	global $cur_filter_check;
	global $self_path;
	global $lr;
	$sql_txt_filter = '';
	if (isset($_SESSION['ll']['links_filter']) and $_SESSION['ll']['links_filter']) {
		$stf = ll_add_slashes($_SESSION['ll']['links_filter']);
		$sql_txt_filter = "(`title` like lower('%$stf%') or `link` like lower('%$stf%') or `return_link` like lower('%$stf%') or `information` like lower('%$stf%') or `banner` like lower('%$stf%') or `add_page` like lower('%$stf%'))";
	}
	if ($cur_page < 0) $cur_page = 0;
	$count_in_page = 10;
	if ($for_admin) {
		$abs_href = '';
		if ($step) $abs_href .= '?step='.$step;
		if ($cur_topic_id) $abs_href .= ($abs_href) ? '&amp;t='.$cur_topic_id : '?t='.$cur_topic_id;
		if ($cur_link) $abs_href .= ($abs_href) ? '&amp;l='.$cur_link : '?l='.$cur_link;
		if ($cur_page) $abs_href .= ($abs_href) ? '&amp;p='.$cur_page : '?p='.$cur_page;
		if ($cur_filter_status) $abs_href .= ($abs_href) ? '&amp;fs='.$cur_filter_status : '?fs='.$cur_filter_status;
		if ($cur_filter_check) $abs_href .= ($abs_href) ? '&amp;fc='.$cur_filter_check : '?fc='.$cur_filter_check;
		$abs_href = $self_path.'_admin.php'.$abs_href;
		$s = '';
		if ($step) $s .= 'step='.$step;
		if ($cur_page) $s .= ($s) ? '&amp;p='.$cur_page : 'p='.$cur_page;
		if ($cur_filter_status) $s .= ($s) ? '&amp;fs='.$cur_filter_status : 'fs='.$cur_filter_status;
		if ($cur_filter_check) $s .= ($s) ? '&amp;fc='.$cur_filter_check : 'fc='.$cur_filter_check;
		if ($s) $s .= '&amp;';
		$href = $self_path.'_admin.php?'.$s;
	} else {
		$href = $self_path.'?';
	}
	$sql_admin = '';
	if ($cur_filter_status) $sql_admin .= " `status`='$cur_filter_status' ";
	switch ($cur_filter_check) {
		case 1:
			if ($sql_admin) $sql_admin .= " and";
			$sql_admin .= " `link_check`=1 ";
			break;
		case 2:
			if ($sql_admin) $sql_admin .= " and";
			$sql_admin .= " `link_check`=0 ";
			break;
		case 3:
			if ($sql_admin) $sql_admin .= " and";
			$sql_admin .= " `link_check`=2 ";
			break;
	}
	$res = '';
	$total_count = 0;
	if ($cur_link > 0) {
		$sql = "select * from `ll_links` where";
		if (!$for_admin) {
			if (is_user_login()) {
				$sql .= " `user_id`=".intval($_SESSION['ll']['ll_edit_uid'])." and";
			} else {
				$sql .= " (`status`='new' or `status`='normal') and";
			}
		}
		$sql .= " `id`=$cur_link";
	} else {
		if ($cur_topic_id != 0) {
			$ids = get_child_ids($cur_topic_id);
			if ($ids) $ids .= ', ';
			$ids .= $cur_topic_id;

			// 
			$sql = "select count(`id`) as `cnt` from `ll_links` where";
			if ($sql_txt_filter) $sql .= " $sql_txt_filter and";
			if (!$for_admin) {
				if (is_user_login()) {
					$sql .= " `user_id`=".intval($_SESSION['ll']['ll_edit_uid'])." and";
				} else {
					$sql .= " (`status`='new' or `status`='normal') and";
				}
			} else {
				if ($sql_admin) $sql .= $sql_admin." and";
			}
			$sql .= " `topic_id` in ($ids)";
			$rs = ll_mysql_query($sql);
			if (mysql_num_rows($rs)) {
				$row = mysql_fetch_array($rs);
				$total_count = $row['cnt'];
			}
			//
			
			$sql = "select * from `ll_links` where";
			if ($sql_txt_filter) $sql .= " $sql_txt_filter and";
			if (!$for_admin) {
				if (is_user_login()) {
					$sql .= " `user_id`=".intval($_SESSION['ll']['ll_edit_uid'])." and";
				} else {
					$sql .= " (`status`='new' or `status`='normal') and";
				}
			} else {
				if ($sql_admin) $sql .= $sql_admin." and";
			}
			$sql .= " `topic_id` in ($ids) order by `title` asc limit ".($cur_page * $count_in_page).", $count_in_page";
		} else {
			
			// 
			$sql_f = '';
			if ($sql_txt_filter) $sql_f .= " $sql_txt_filter";
			if (!$for_admin) {
				if (is_user_login()) {
					if ($sql_f) $sql_f .= " and ";
					$sql_f .= " `user_id`=".intval($_SESSION['ll']['ll_edit_uid'])."";
				} else {
					if ($sql_f) $sql_f .= " and ";
					$sql_f .= " (`status`='new' or `status`='normal')";
				}
			} else {
				if ($sql_admin) {
					if ($sql_f) $sql_f .= " and ";
					$sql_f .= " $sql_admin";
				}
			}
			$sql = "select count(`id`) as `cnt` from `ll_links`";
			if ($sql_f) $sql .= " where $sql_f";
			$rs = ll_mysql_query($sql);
			if (mysql_num_rows($rs)) {
				$row = mysql_fetch_array($rs);
				$total_count = $row['cnt'];
			}
			
			$sql_f = '';
			if ($sql_txt_filter) $sql_f .= " $sql_txt_filter";
			if (!$for_admin) {
				if (is_user_login()) {
					if ($sql_f) $sql_f .= " and ";
					$sql_f .= " `user_id`=".intval($_SESSION['ll']['ll_edit_uid'])."";
				} else {
					if ($sql_f) $sql_f .= " and ";
					$sql_f .= " (`status`='new' or `status`='normal')";
				}
			} else {
				if ($sql_admin) {
					if ($sql_f) $sql_f .= " and ";
					$sql_f .= " $sql_admin";
				}
			}
			$sql = "select * from `ll_links`";
			if ($sql_f) $sql .= " where $sql_f";
			$sql .= " order by `title` asc limit ".($cur_page * $count_in_page).", $count_in_page";
		}
	}
	$rs = ll_mysql_query($sql);
	if (mysql_num_rows($rs)) {
		while ($row = mysql_fetch_array($rs)) {
			$res .= '<li style="margin-bottom:';
			if ($for_admin) {
				$res .= ' 4px; padding: 4px 6px;';
			} else {
				$res .= ' 12px;';
			}
			if ($row['status'] == 'none') {
				$res .= ' background-color: #E2ECBD;';
			} elseif ($row['status'] == 'new') {
				$res .= ' background-color: #FFEC93;';
			} elseif ($row['status'] == 'hide') {
				$res .= ' background-color: #E0EBFF;';
			} else {
				$res .= ' background-color: #FFFFFF;';
			}
			$res .= '"';
			if ($cur_link > 0) {
				$res .= '><span style="font-weight: bold;">'.ll_strip_slashes($row['title']).'</span>';
			} else {
				if ($row['status'] == 'normal' or $for_admin) {
					if ($cur_topic_id) {
						$hs = 't='.$cur_topic_id.'&amp;l='.$row['id'];
					} else {
						$hs = 'l='.$row['id'];
					}
					$res .= '><a href="'.$href.$hs.'" style="font-weight: bold;">'.ll_strip_slashes($row['title']).'</a>';
				} else {
					$res .= '><span style="font-weight: bold;">'.ll_strip_slashes($row['title']).'</span>';
				}
			}
			if ($row['status'] == 'new') {
				$res .= '<span style="margin-left: 40px;">[ '.strtolower($lr[59]).' ]</span>';
			} elseif ($row['status'] == 'hide') {
				$res .= '<span style="margin-left: 40px;">[ '.strtolower($lr[60]).' ]</span>';
			}
			if (is_user_login()) {
				$res .= '<span style="margin-left: 40px;">[ ';
				$rp = '';
				if ($cur_topic_id) $rp .= '?t='.$cur_topic_id;
				if ($cur_link) $rp .= ($rp) ? '&amp;l='.$cur_link : '?l='.$cur_link;
				$rp = ll_encode($self_path.$rp);
				$res .= '<a href="_edit.php?l='.$row['id'].'&amp;rp='.$rp.'">'.$lr[56].'</a>';
				$res .= ' | ';
				$res .= '<a style="cursor: pointer;" onclick="javascript: if (confirm(\''.$lr[13].' '.ll_strip_slashes($row['link']).'?\')) document.getElementById(\'form_link_user_del_'.$row['id'].'\').submit();">'.$lr[13].'</a>';
				$res .= ' ]</span>';
				$res .= '<form id="form_link_user_del_'.$row['id'].'" name="form_link_user_del_'.$row['id'].'" method="post" action="" enctype="multipart/form-data" target="_self" style="float: left;">';
				$res .= '<input name="user_delete_link" type="hidden" id="user_delete_link" value="1" />';
				$res .= '<input name="user_delete_link_id" type="hidden" id="user_delete_link_id" value="'.$row['id'].'" />';
				$res .= '</form>';
			}
			if (!$for_admin) {
				$res .= '<div class="text_medium" style="color: #999999">'.$lr[30].': '.get_topic_full_title($row['topic_id']).'</div>';
			}
			$res .= '<div style="padding: 2px 0px;">'.ll_strip_slashes($row['information']);
			if ($cur_link > 0 and ($row['status'] == 'normal' or $for_admin)) {
				$res .= '<div style="padding-top: 4px;">';
				if (!empty($row['banner'])) {
					$res .= ll_strip_slashes($row['banner']);
				} else {
					$res .= $lr[19].': <a href="'.ll_strip_slashes($row['link']).'" target="_blank" style="color: #448800;">'.ll_strip_slashes($row['title']).'</a>';
				}
				$res .= '</div>';
				$res .= '<div style="padding-top: 6px;">';
				$url = ll_strip_slashes($row['link']);
				if (($k = strpos($url, '//')) !== false) {
					$url = substr($url, $k + 2);
				}
				$res .= '<br /><img src="http://www.cy-pr.com/i/'.$url.'_1_107.138.206.gif" border="0" width="88" height="31" alt="Seo  , " /><!-- cy-pr.com -->';
				//$res .= '<br /><!-- cy-pr.com --><a rel="noindex, nofollow" href="http://www.cy-pr.com/" target="_blank"><img src="http://www.cy-pr.com/i/'.$url.'_1_107.138.206.gif" border="0" width="88" height="31" alt="Seo  , " /></a><!-- cy-pr.com -->';
				//$res .= '<a rel="noindex, nofollow" title="   PR"><img src="http://counter.pr-cy.ru/prcy/'.$url.'" alt="PR-CY.ru" width="88" height="31" border="0" /></a>';
				$res .= '</div>';
			}
			if ($for_admin) {
				$res .= ' <div style="padding-top: 6px;"><form id="form_link_topic" name="form_link_topic" method="post" action="" enctype="multipart/form-data" target="_self">'.str_replace('<select ', '<select onchange="javascript: this.form.submit();" ', build_topics_for_select($row['topic_id'], true)).'<input name="link_id" type="hidden" id="link_id" value="'.$row['id'].'" /></form></div>';
				$res .= '<div style="margin-top: 4px; padding: 2px 6px; color: #777777; background-color: #EFEFEF; font-size: 90%">';
				$s = ll_strip_slashes($row['added']);
				$user = get_user($row['user_id']);
				if (is_array($user)) {
					$ss = ll_strip_slashes($user['email']);
					$s .= ' &nbsp;(<a href="mailto:'.$ss.'">'.$ss.'</a>)';
				}
				$res .= $lr[97].': '.$s.'<br />';
				$ss = ll_strip_slashes($row['link']);
				$res .= 'URL: <a href="'.$ss.'" target="_blank">'.$ss.'</a><br />';
				$res .= '<span';
				if ($row['status'] == 'normal') {
					if ($row['link_check'] == 0) {
						$res .= ' style="color: #FF0000;"';
					}
				}
				$res .= '>'.$lr[41].':</span> ';
				$ss = ll_strip_slashes($row['return_link']);
				$res .= '<a href="'.$ss.'" target="_blank">'.$ss.'</a><br />';
				$ss = ll_strip_slashes($row['add_page']);
				$res .= $lr[49].': <a href="'.$ss.'" target="_blank">'.$ss.'</a>';
				$res .= '</div>';
				$res .= '<form id="form_link_status" name="form_link_status" method="post" action="'.$abs_href.'" enctype="multipart/form-data" target="_self" style="padding: 6px 0px; border-bottom: 2px solid #EEEEEE;">';
				$res .= '<span style="margin-right: 8px;">'.$lr[37].':</span>';
				$res .= build_status_for_select('select_one_link_status', $row['status'], false, 'javascript: this.form.submit();');
				$res .= '<span style="margin-left: 20px; margin-right: 8px;">'.$lr[38].':</span><select name="select_one_link_check" id="select_one_link_check" onchange="javascript: this.form.submit();">';
				$sel = ($row['link_check'] == 0) ? 'selected="selected"' : '';
				$res .= '<option value="-1" '.$sel.'>'.$lr[46].'</option>';
				$sel = ($row['link_check'] == 1) ? 'selected="selected"' : '';
				$res .= '<option value="1" '.$sel.'>'.$lr[45].'</option>';
				$sel = ($row['link_check'] == 2) ? 'selected="selected"' : '';
				$res .= '<option value="2" '.$sel.'>'.$lr[88].'</option>';
				$res .= '</select>';
				$res .= '<input type="button" value="'.$lr[56].'" onclick="javascript: document.location.href = \'_edit.php?l='.$row['id'].'&amp;rp='.ll_encode($abs_href).'\';" style="margin-left: 20px;" />';
				$res .= '<input name="check_one_link" type="submit" id="check_one_link" value="'.$lr[86].'" style="margin-left: 20px;" />';
				$res .= '<input name="delete_one_link" type="submit" id="delete_one_link" value="'.$lr[13].'" onclick="javascript: if (!confirm(\''.$lr[13].' '.ll_strip_slashes($row['link']).'?\')) return false;" style="margin-left: 20px;" />';
				$res .= '<input name="link_id" type="hidden" id="link_id" value="'.$row['id'].'" />';
				global $check_one_link_result;
				if (isset($_POST['link_id']) and $_POST['link_id'] == $row['id'] and $check_one_link_result) $res .= '<div class="text_medium" style="color: #000000; margin-top: 6px; padding: 4px; background-color: #FFFFCC; border: 1px solid #CC9900;">'.$lr[87].': '.$check_one_link_result.'</div>';
				$res .= '</form>';
			} else {
				if (is_user_login()) {
					$res .= '<div style="margin-top: 4px; padding: 2px 6px; background-color: #EFEFEF; font-size: 90%">';
					$res .= $lr[97].': '.ll_strip_slashes($row['added']).'<br />';
					$res .= $lr[37].': '.ll_strip_slashes($row['status']).'</div>';
				}
			}
			$res .= '</div></li>';
		}
	}
	if ($res) $res = '<ol start="'.intval($cur_page * $count_in_page + 1).'">'.$res.'</ol>';
	if ($total_count > 0) {
		$res .= '<div style="margin: 20px 20px 10px 20px;">';
		$res .= $lr[33].': '.$total_count;
		if ($total_count > $count_in_page) {
			$res .= '<br />'.$lr[34].': ';
			$pages_count = ceil($total_count / $count_in_page);
			if ($for_admin) {
				$href = $self_path.'_admin.php?step='.$step.'&amp;';
			} else {
				$href = $self_path.'?';
			}
			if ($cur_filter_status) $href .= 'fs='.$cur_filter_status.'&amp;';
			if ($cur_filter_check) $href .= 'fc='.$cur_filter_check.'&amp;';
			if ($cur_topic_id > 0) $href .= 't='.$cur_topic_id.'&amp;';
			for ($i = 0; $i < $pages_count; $i++) {
				if ($cur_page == $i) {
					$res .= ($i + 1).'&nbsp;';
				} else {
					$res .= '<a href="'.$href.'p='.$i.'">'.($i + 1).'</a>&nbsp;';
				}
			}
		}
		$res .= '</div>';
	}
	return $res;
}

function build_status_for_select($select_name, $select_val, $add_all, $event_change) {
	global $lr;
	$res = '<select name="'.$select_name.'" id="'.$select_name.'"';
	if ($event_change) $res .= ' onchange="'.$event_change.'"';
	$res .= '>';
	if ($add_all) {
		$sel = ($select_val == '') ? 'selected="selected"' : '';
		$res .= '<option value="" '.$sel.'>&lt;'.$lr[32].'&gt;</option>';
	}
	$sel = ($select_val == 'none') ? 'selected="selected"' : '';
	$res .= '<option value="none" '.$sel.'>none</option>';
	$sel = ($select_val == 'new') ? 'selected="selected"' : '';
	$res .= '<option value="new" '.$sel.'>new</option>';
	$sel = ($select_val == 'normal') ? 'selected="selected"' : '';
	$res .= '<option value="normal" '.$sel.'>normal</option>';
	$sel = ($select_val == 'hide') ? 'selected="selected"' : '';
	$res .= '<option value="hide" '.$sel.'>hide</option>';
	$res .= '</select>';
	return $res;
}

function build_checked_for_select($select_name, $select_val, $add_all, $event_change) {
	global $lr;
	$res = '<select name="'.$select_name.'" id="'.$select_name.'"';
	if ($event_change) $res .= ' onchange="'.$event_change.'"';
	$res .= '>';
	if ($add_all) {
		$sel = ($select_val == '') ? 'selected="selected"' : '';
		$res .= '<option value="0" '.$sel.'>&lt;'.$lr[32].'&gt;</option>';
	}
	$sel = ($select_val == '1') ? 'selected="selected"' : '';
	$res .= '<option value="1" '.$sel.'>'.$lr[45].'</option>';
	$sel = ($select_val == '2') ? 'selected="selected"' : '';
	$res .= '<option value="2" '.$sel.'>'.$lr[46].'</option>';
	$sel = ($select_val == '3') ? 'selected="selected"' : '';
	$res .= '<option value="3" '.$sel.'>'.$lr[88].'</option>';
	$res .= '</select>';
	return $res;
}

function ll_extract_link($link) {
	$res = $link;
	if ($link) {
		$h = @parse_url($res);
		if ($h and is_array($h) and array_key_exists('host', $h) and $h['host']) {
			$res = $h['host'];
		}
	}
	if (strpos(strtolower($res), 'http://') === 0) $res = substr($res, 7);
	if (strpos(strtolower($res), 'www.') === 0) $res = substr($res, 4);
	return $res;
}

function is_link_exists($link) {
	$link = ll_add_slashes(ll_extract_link($link));
	$sql = "select * from `ll_links` where `link`='http://$link' or `link`='http://www.$link' limit 1";
	$rs = ll_mysql_query($sql);
	if (mysql_num_rows($rs)) {
		$row = mysql_fetch_array($rs);
		return intval($row['id']);
	}
	return false;
}

function is_user_exists($login, $password) {
	$login = ll_add_slashes($login);
	$password = ll_add_slashes(strtolower($password));
	$sql = "select * from `ll_users` where `login`='$login' and `password`='$password' limit 1";
	$rs = ll_mysql_query($sql);
	if (mysql_num_rows($rs)) {
		$row = mysql_fetch_array($rs);
		return intval($row['id']);
	}
	return false;
}

function is_login_exists($login) {
	$login = ll_add_slashes($login);
	$password = ll_add_slashes(strtolower($password));
	$sql = "select * from `ll_users` where `login`='$login' limit 1";
	$rs = ll_mysql_query($sql);
	if (mysql_num_rows($rs)) {
		$row = mysql_fetch_array($rs);
		return intval($row['id']);
	}
	return false;
}

function get_user_login($id) {
	$sql = "select `id`, `login` from `ll_users` where `id`='$id' limit 1";
	$rs = ll_mysql_query($sql);
	if (mysql_num_rows($rs)) {
		$row = mysql_fetch_array($rs);
		return ll_strip_slashes($row['login']);
	}
	return false;
}

function get_user_email($id) {
	$sql = "select `id`, `email` from `ll_users` where `id`='$id' limit 1";
	$rs = ll_mysql_query($sql);
	if (mysql_num_rows($rs)) {
		$row = mysql_fetch_array($rs);
		return ll_strip_slashes($row['email']);
	}
	return false;
}

function get_user($id) {
	$res = '';
	$sql = "select * from `ll_users` where `id`='$id' limit 1";
	$rs = ll_mysql_query($sql);
	if (mysql_num_rows($rs)) {
		$res = mysql_fetch_array($rs);
	}
	return $res;
}

function check_str($str) {
	$res = trim(preg_replace ("/[^\x20-\xFF]/", "", @strval($str)));
	$res = ll_strip_slashes($res);
	return $res;
}

function ll_check_login($login) {
	if (strlen($login) == 0) return false;
	$ctrl_str = preg_quote(' !@#$%^&*()|\\/[]{}<>?;:,."\''."'", '/');
	if (preg_match('/(['.$ctrl_str.'])/i', $login)) return false;
	return true;
}

function ll_check_password($password) {
	if (!ll_check_login($password)) return false;
	if (strlen($password) < 7) return false;
	return true;
}

function ll_check_email($email) {
	if (strlen($email) == 0) return false;
	$array = explode("@", $email);
	if (preg_match("/[_\.-]{2}/", $array[0])) return false;
	if (preg_match("/[_\.-]{1}$/", $array[0])) return false;
	if (!preg_match ("/(\S+)\@(\S+)\.(\S+)/i", $email)) return false;
	if (strchr($email,"'") || strchr($email,'"') || strchr($email,'/') || strchr($email,'&') || strchr($email,',') || strchr($email,';') || strchr($email,'\\')) return false;
	return true;
}

function ll_check_link($link) {
	if (strlen($link) == 0) return false;
	//if (!preg_match('/((http|https|ftp):\/\/|www.)[A-Za-z0-9\.\-\/_\?\#\%\+]+/i', $link)) return false;
	if (!preg_match('/((http|https|ftp):\/\/|www.)[A-Za-z0-9\.\-\/_]+\.+[A-Za-z0-9\.\-\/_\?\#\%\+]+/i', $link)) return false;
	//if (strchr($link,"'") || strchr($link,'"') || strchr($link,'&') || strchr($link,';') || strchr($link,'\\')) return false;
	return true;
}

function build_topics_for_select($topic_sel_id, $add_parent_title = false) {
	global $lr;
	$res = '<select name="li_topic_select" id="li_topic_select">';
	$res .= '<option value="0">&lt;'.$lr[48].'&gt;</option>';
	$topics_arr = get_topics();
	reset($topics_arr);
	foreach ($topics_arr as $v) {
		if ($v['topic_id'] == 0) {
			$res .= '<optgroup label="'.ll_strip_slashes($v['title']).'">';
			$res .= build_subtopics_for_select($topics_arr, $v['id'], $topic_sel_id);
			$res .= '</optgroup>';
		}
	}
	$res .= '</select>';
	if ($add_parent_title) {
		foreach ($topics_arr as $v) {
			if ($v['topic_id'] == 0 and is_child($topics_arr, $v['id'], $topic_sel_id)) {
				$res = ll_strip_slashes($v['title']).'&nbsp;&rarr;&nbsp;'.$res;
				break;
			}
		}
	}
	return $res;
}

function build_subtopics_for_select($topics_arr, $topic_id, $topic_sel_id) {
	$res = '';
	foreach ($topics_arr as $v) {
		if ($v['topic_id'] == $topic_id) {
			$res .= '<option value="'.intval($v['id']).'"';
			if ($v['id'] == $topic_sel_id) $res .= ' selected="selected"';
			$res .= '>'.ll_strip_slashes($v['title']).'</option>';
		}
	}
	return $res;
}

function check_return_link($return_link, $link) {
	if (empty($link)) return '<span style="color: #FF0000;">self link empty;</span> ';
	if (empty($return_link)) return '<span style="color: #FF0000;">return link empty;</span> ';
	$res = '';
	if ($h = @parse_url($return_link)) {
		if (gethostbyname($h['host']) == $h['host']) {
			$res .= '<span style="color: #FF0000;">host not found;</span> ';
		} else {
			$sl = ll_extract_link($h['host']);
			if ($sl == $link) return 'return link to self; ';
			$res .= 'host ok; ';
			$line = ll_get_file_context($return_link);
			if (!$line) {
				$res .= '<span style="color: #FF0000;">return link file not found;</span> ';
			} else {
				$res .= 'return link file ok; ';
				$preg_link = str_replace('-', '\-', $link);
				$preg_link = str_replace('+', '\+', $preg_link);
				$preg_link = str_replace('/', '\/', $preg_link);
				$preg_link = str_replace('"', '\"', $preg_link);
				/*if (preg_match("/<\s?a\s.*?href\s?=\s?\"?'?\s?(http:\/\/(www.)?(".$preg_link.")+)\/?\s?\"?'?.*?>(.*?)<\s?\/\s?a\s?>/si", $line, $matches)) {  1*/
				/*if (preg_match("/<\s*?a.*? href\s*?=\s*?[\"']?\s*?(http:\/\/(www\.)?".$preg_link.")\/?\s*?[\"'\s]+.*?>/si", $line, $matches)) {  2*/
				//preg_match_all("/href\s*=[^>]*\s*[\"']*(".$preg_link.")[\"'\s>]*/Usi", $line, $matches))  3
				
				preg_match_all("/href\s*=[^>]*\s*[\"']*(".$preg_link.")[\"'\s>]*/Usi", $line, $matches);
				//echo $matches[0][0].'<br />';
				//echo count($matches[0]).'<br />';
				//echo count($matches[0][0]).'<br />';
				//if (!is_array($matches[0][0])) echo 'no array<br />';
				//if (stristr($matches[0][0], $link) !== false) echo 'stristr true<br />';
				if (is_array($matches) and count($matches) and is_array($matches[0]) and count($matches[0]) and !is_array($matches[0][0]) and stristr($matches[0][0], $link) !== false) {
					$res .= 'return link exists ok; ';
					/*if (preg_match("/(content=[^<]\s?[\"']?\s?(index)?\s?,?\s?(follow)?\s?,?\s?(noindex|nofollow|none)[\"']?)/si", $line, $matches)) { */
					if (preg_match("/(content=[^<]\s?[\"']?\s?(index)?\s?,?\s?(follow)?\s?,?\s?(noindex|nofollow|none)[\"']?)/si", $line, $matches)) {
						$res .= '<span style="color: #FF0000;">return link indexed fail;</span> ';
						//echo '<pre>';
						//print_r($matches);
						//echo '</pre>';
					} else {
						$res .= 'return link indexed ok; ';
						//echo '<pre>';
						//print_r($matches);
						//echo '</pre>';
					}
				} else {
					$res .= '<span style="color: #FF0000;">return link not found;</span> ';
				}
				//echo htmlspecialchars($line);
				//echo $return_link.'<br />';
			}
		}
	} else {
		$res = '<span style="color: #FF0000;">return link bad;</span> ';
	}
	return $res;
}

function get_mylink() {
	$res = '';
	if (file_exists('_mysite.txt')) {
		$s = ll_get_file_context('_mysite.txt');
		if ($s) {
			$s = ll_decode($s);
			$arr = explode('::::', $s);
			if (is_array($arr) and count($arr) > 4) $res = trim($arr[4]);
		}
	}
	return $res;
}

function get_myemail() {
	$res = '';
	if (file_exists('_mysite.txt')) {
		$s = ll_get_file_context('_mysite.txt');
		if ($s) {
			$s = ll_decode($s);
			$arr = explode('::::', $s);
			if (is_array($arr) and count($arr) > 1) $res = trim($arr[1]);
		}
	}
	return $res;
}

function link_change_status($ids, $new_status) {
	$sql = "update `ll_links` set `status`='$new_status',";
	if ($new_status == 'normal') {
		$sql .= " `link_check`=1";
	} else {
		$sql .= " `link_check`=0";
	}
	$sql .= " where `id` in ($ids)";
	ll_mysql_query($sql);
}

function ll_mailing($to, $from, $subject, $message) {
	
	//
	//echo $message.'<br /><br />';
	//return;
	//end 
	
	//$to = convert_cyr_string($to, "w","k")."\r\n";
	//$from = convert_cyr_string($from, "w","k")."\r\n";
	//$message = convert_cyr_string($message, "w","k")."\r\n";
	$headers = "MIME-Version: 1.0\r\n";
	//$headers .= "Content-type: text/html; charset=koi8-r\r\n";
	$headers .= "Content-type: text/html; charset=windows-1251\r\n";
	$headers .= "From: ".$from."\r\nX-Mailer: PHP/".phpversion();
	$res = @mail($to, $subject, wordwrap($message, 76, "\r\n", 0), $headers);
	return $res;
}

function is_admin_login() {
	global $ll_login;
	global $ll_password;
	if (isset($_SESSION) and isset($_SESSION['ll']) and isset($_SESSION['ll']['ll_login']) and isset($_SESSION['ll']['ll_password']) and $_SESSION['ll']['ll_login'] == $ll_login and $_SESSION['ll']['ll_password'] == $ll_password) {
		$res = true;
	} else {
		$res = false;
	}
	return $res;
}

function is_user_login() {
	if (isset($_SESSION) and isset($_SESSION['ll']) and isset($_SESSION['ll']['ll_edit_ulogin']) and $_SESSION['ll']['ll_edit_ulogin'] and isset($_SESSION['ll']['ll_edit_upassword']) and $_SESSION['ll']['ll_edit_upassword'] and isset($_SESSION['ll']['ll_edit_uid']) and $_SESSION['ll']['ll_edit_uid']) {
		$res = true;
	} else {
		$res = false;
	}
	return $res;
}
?>